function Vadm(action)

global vectors names dependences index old_scale_factor

switch action

case 'show norm'
   if isempty(names{index})
      name='v';
   else
      name=names{index};
   end
   XLim=get(gca,'XLim');
   dx=diff(XLim);
   p=vectors(1:2,index);
   n=norm(p);
   hn=findobj(gcbf,'Tag','norm');
   set(hn,'String',['|| ' name ' || = ' num2str(n,'%1.1f')])
   title([name ' = ( ' num2str(p(1),'%1.1f') ', ' num2str(p(2),'%1.1f') ' )'])
   
   
case 'save as'
   h=findobj(gcbf,'Tag','name');
   name=get(h,'String');
   names{index}=name;
   dependences=delete_deps(dependences,index);
   Vadm('update graphics')
   
   
case 'clear'
   vectors=[];
   old_scale_factor=1;
   h=findobj(gcbf,'Tag','scale slider');
   set(h,'Value',1)
   h=findobj(gcbf,'Tag','v-text');
   set(h,'Visible','off')
   h=findobj(gcbf,'Type','text');
   delete(h)
   names={};
   dependences={}
   title('');
   Vadm('update graphics')
   
   
case 'delete'
   oi=index;
   index=get_index(vectors);
   dependences=delete_deps(dependences,index);
   indices=1:size(vectors,2);
   indices=indices(indices~=index);
   vectors=vectors(:,indices);
   names=names(indices);
   if index==oi
      title('')
   end
   Vadm('update graphics')


case 'select'
   index=get_index(vectors);
   vectors(3,:)=1; vectors(3,index)=2;
   Vadm('show norm')
   Vadm('update graphics')
   
   
case 'new'
   p=eval(get(findobj(gcbf,'Tag','new'),'String'));
   vectors=[vectors [p 2 0]'];
   index=size(vectors,2);
   vectors(3,:)=1; vectors(3,index)=2;
   names{index}='';
   Vadm('show norm')
   Vadm('update graphics')
   set(gcbf,'WindowButtonDownFcn','Vadm(''edit'')')
    

case 'update dependences'
   l=size(dependences,2);
   for i=1:l
      v1=dependences{1,i};
      v2=dependences{2,i};
      v3=dependences{3,i};
      op=dependences{4,i};
      p=vectors(1:2,v1);
      q=vectors(1:2,v2);
      if op=='+'
         s=p+q;
      elseif op=='-'
         s=p-q;
      elseif op=='*'
         s=[p(1)*q(1)-p(2)*q(2);p(1)*q(2)+p(2)*q(1)];
      elseif op=='/'
         s=[p(1)*q(1)+p(2)*q(2);-p(1)*q(2)+p(2)*q(1)]/norm(q)^2;
      elseif op=='P'
         s=dot(p,q)/norm(q)^2*q;
      elseif op=='d'
         s=dot(p,q);
         title([names{v1} '.' names{v2} ' = ' num2str(s,'%1.1f')])
         set(findobj(gcbf,'Tag','norm'),'Visible','off')
      end
      vectors(1:2,v3)=s;
   end
   
   
case 'update graphics'
   h=findobj(gcbf,'Type','line','Color','b');
   delete(h)
   h=findobj(gcbf,'Type','text');
   delete(h)
   if isempty(names)
   else
      if index<=length(names) & isempty(names{index})
         names{index}='v';
      end
   end
   for i=1:size(vectors,2)
      p=vectors(:,i);
      [X,Y]=arrow(p(1:2));
      h=line(X,Y,'LineWidth',p(3),'Tag',num2str(i));
      XLim=get(gca,'XLim');
      dx=diff(XLim);
      n=norm(p(1:2));
      pos=3*p(1:2)/5+[-p(2);p(1)]/n*dx/30;
      ht=text(pos(1),pos(2),names{i});
      if names{i}=='d'
         delete(h)
         delete(ht)
      end
   end

   
case 'create'
   cp=get(gca,'CurrentPoint'); p=cp(1,1:2);
   vectors=[vectors [p 2 0 ]'];
   index=size(vectors,2);
   names{index}='';
   Vadm('select')
   set(gcbf,'WindowButtonMotionFcn','Vadm(''WBMF'')','WindowButtonUpFcn','Vadm(''WBUF'')')
    

case 'edit'
   index=get_index(vectors);
   Vadm('select')
   set(gcbf,'WindowButtonMotionFcn','Vadm(''WBMF'')','WindowButtonUpFcn','Vadm(''WBUF'')')
   
   
case 'add'
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   vectors(3,index)=2;
   Vadm('update graphics')
   pause(1)
   q=vectors(1:2,index);
   s=p+q;
   line([p(1) s(1)],[p(2) s(2)],'color',[0 0 0],'Tag','temp')
   line([q(1) s(1)],[q(2) s(2)],'color',[0 0 0],'Tag','temp')
   pause(1)
   vectors=[vectors [s' 2 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      names{index}=[n1 '+' n2];
   end
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='+'
   Vadm('update graphics')
   
   
case 'sub'
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   vectors(3,index)=2;
   Vadm('update graphics')
   pause(1)
   q=vectors(1:2,index);
   s=p-q;
   line([0 -q(1)],[0 -q(2)],'Color',[0 0 .9],'Tag','temp')
   pause(2)
   line([p(1) s(1)],[p(2) s(2)],'color',[0 0 0],'Tag','temp')
   line([-q(1) s(1)],[-q(2) s(2)],'color',[0 0 0],'Tag','temp')
   pause(1)
   vectors=[vectors [s' 2 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      names{index}=[n1 '-' n2];
   end
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='-';
   Vadm('update graphics')
   
   
case 'compl *'
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   vectors(3,index)=2;
   Vadm('update graphics')
   pause(1)
   q=vectors(1:2,index);
   s=[p(1)*q(1)-p(2)*q(2);p(1)*q(2)+p(2)*q(1)];
   vectors=[vectors [s' 2 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      names{index}=[n1 '*' n2];
   end
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='*';
   Vadm('update graphics')
   
   
case 'compl /'
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   vectors(3,index)=2;
   Vadm('update graphics')
   pause(1)
   q=vectors(1:2,index);
   s=[p(1)*q(1)+p(2)*q(2);-p(1)*q(2)+p(2)*q(1)]/norm(q)^2;
   vectors=[vectors [s' 2 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      names{index}=[n1 '/' n2];
   end
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='/';
   Vadm('update graphics')
   
   
case 'project onto'
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   Vadm('update graphics')
   q=vectors(1:2,index);
   s=dot(p,q)/norm(q)^2*q;
   line([p(1) s(1)],[p(2) s(2)],'color',[0 0 0],'Tag','temp')
   pause(1)
   vectors=[vectors [s' 3 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      si=[];
      for i=1:length(n2)
         si=[si '_' n2(i)];
      end
      names{index}=['P' si n1];
   end
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='P';
   h=findobj(gcbf,'Tag','norm');
   set(h,'String',[n1 '.' n2 ' = ' num2str(dot(p,q),'%1.1f')])
   Vadm('update graphics')
   
   
case 'dot'
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   Vadm('update graphics')
   q=vectors(1:2,index);
   s=dot(p,q)/norm(q)^2*q;
   line([p(1) s(1)],[p(2) s(2)],'color',[0 0 0],'Tag','temp')
   pause(1)
   vectors=[vectors [s' 3 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      si=[];
      for i=1:length(n2)
         si=[si '_' n2(i)];
      end
      names{index}=['P' si n1];
   end
   names{index}='d';
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='d';
   h=findobj(gcbf,'Tag','norm');
   title([n1 '.' n2 ' = ' num2str(dot(p,q),'%1.1f')])
   Vadm('update graphics')
   
   
case 'normalize'
   p=vectors(1:2,index);
   p=p/norm(p);
   vectors(1:2,index)=p;
   old_scale_factor=1;
   h=findobj(gcbf,'Tag','scale slider');
   set(h,'Value',1)
   Vadm('show norm')
   Vadm('update graphics')
   
   
case 'invert'
   index=get_index(vectors);
   Vadm('select')
   p=vectors(1:2,index);
   vectors(1:2,index)=-p;
   Vadm('show norm')
   Vadm('update graphics')


case 'slide scale'
   h=findobj(gcbf,'Tag','scale slider');
   val=get(h,'Value');
   h=findobj(gcbf,'Tag','scale');
   set(h,'String',num2str(val))
   Vadm('scale')
   
   
case 'scale'
   h=findobj(gcbf,'Tag','scale');
   sf=eval(get(h,'String'));
   p=vectors(1:2,index);
   if get(gcf,'CurrentObject')==findobj(gcbf,'Tag','scale slider')
      p=sf/old_scale_factor*p;
      old_scale_factor=sf;
   else
      p=sf*p;
   end
   vectors(1:2,index)=p;
   Vadm('show norm')
   Vadm('update graphics')
   
   
case 'WBUF'
   set(gcbf,'WindowButtonMotionFcn','','WindowButtonUpFcn','')
   
   
case 'WBMF'
   cp=get(gca,'CurrentPoint'); p=cp(1,1:2)';
   vectors(1:2,index)=p;
   Vadm('show norm')
   Vadm('update dependences')
   Vadm('update graphics') 


case 'A'
   disp('to appear..')
   return
   p=vectors(1:2,index);
   n1=names{index};
   l=size(dependences,2)+1;
   dependences{1,l}=index;
   index=get_index(vectors);
   n2=names{index};
   dependences{2,l}=index;
   vectors(3,index)=2;
   Vadm('update graphics')
   pause(1)
   q=vectors(1:2,index);
   s=[p(1)*q(1)-p(2)*q(2);p(1)*q(2)+p(2)*q(1)];
   vectors=[vectors [s' 2 0]'];
   index=size(vectors,2);
   if isempty(n1) | isempty(n2)
      names{index}=''
   else
      names{index}=[n1 '*' n2];
   end
   Vadm('update graphics')
   pause(2)
   delete(findobj(gcbf,'Tag','temp'))
   vectors(3,:)=1; vectors(3,index)=2;
   dependences{3,l}=index;
   dependences{4,l}='*';
   Vadm('update graphics')
   
   
   
case 'Au'
   u=vectors(1:2,index);
   hA=findobj(gcbf,'Tag','A');
   A=get(hA,'String');
   A=eval(A);
   u=A*u;
   vectors(1:2,index)=u;
   Vadm('update graphics')


case 'invAu'
   u=vectors(1:2,index);
   hA=findobj(gcbf,'Tag','A');
   A=get(hA,'String');
   A=eval(A);
   u=inv(A)*u;
   vectors(1:2,index)=u;
   Vadm('update graphics')


case 'dot'
   if ~isempty(index)
      index1=index;
      Vadm('select')
      index2=index;
      h=findobj(gcbf,'Type','line','Color',[1 0 0]);
      X_a=get(h(index1),'XData');
      Y_a=get(h(index1),'YData');
      X_b=get(h(index),'XData');
      Y_b=get(h(index),'YData');
      X_b=X_a(1)+(X_b-X_b(1));
      Y_b=Y_a(1)+(Y_b-Y_b(1));
      set(h(index),'XData',X_b,'YData',Y_b)
      p=[X_a(1) Y_a(1)];
      n=[X_a(2)-X_a(1) Y_a(2)-Y_a(1)];
      v=[X_b(2)-X_b(1) Y_b(2)-Y_b(1)];
      q=[n(2) -n(1)];
      r=[p;p+q;p+dot(v,n)/norm(n)^2*n+q;p+dot(v,n)/norm(n)^2*n];
      hp=patch(r(:,1),r(:,2),'y');
      set(hp,'Tag','temp','FaceColor','y')
      set(gca,'ButtonDownFcn','Vadm(''start'')')
   end


case 'LS'
   h=findobj('Type','line','Color',[1 0 0]);
   A=[];
   b=[];
   for j=1:length(h)
      X=get(h(j),'XData');
      X=X(1:2);
      Y=get(h(j),'YData');
      Y=Y(1:2);
      n=[diff(X) diff(Y)];
      p=[X(1) Y(1)];
      A=[A;n];
      b=[b;n*p'];
   end
   LS=(A'*A)\(A'*b);
   h=findobj(gcbf,'Tag','LS');
   delete(h)


case 'zoom out'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   NewXLim=[XLim(1)-diff(XLim)/8 XLim(2)+diff(XLim)/8];
   NewYLim=[YLim(1)-diff(YLim)/8 YLim(2)+diff(YLim)/8];
   set(gca,'XLim',NewXLim,...
           'YLim',NewYLim)
   set(findobj(gcbf,'Tag','x_axis'),'XData',NewXLim)
   set(findobj(gcbf,'Tag','y_axis'),'YData',NewYLim)
   Vadm('show norm')
   Vadm('update graphics')
    
    
case 'zoom in'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   NewXLim=[XLim(1)+diff(XLim)/10 XLim(2)-diff(XLim)/10];
   NewYLim=[YLim(1)+diff(YLim)/10 YLim(2)-diff(YLim)/10];
   set(gca,'XLim',NewXLim,...
           'YLim',NewYLim)
   set(findobj(gcbf,'Tag','x_axis'),'XData',NewXLim)
   set(findobj(gcbf,'Tag','y_axis'),'YData',NewYLim)
   Vadm('show norm')
   Vadm('update graphics')
   
    
end


function [X,Y]=arrow(p)
   XLim=get(gca,'XLim');
   dx=diff(XLim);
   s=(norm(p)+eps);
   X=[0 1 1-.01*dx/s 1-.02*dx/s 1-.01*dx/s...
        1 1-.01*dx/s 1-.02*dx/s];
   Y=[0 0  .003*dx/s  .01*dx/s  .003*dx/s...
        0 -.003*dx/s -.01*dx/s];
   v=atan2(p(2),p(1));
   XY=[cos(v) -sin(v);
   sin(v) cos(v)]*[X;Y];
   XY=[s 0;0 s]*XY;
   X=XY(1,:); Y=XY(2,:);


function index=get_index(vectors)
   cp=get(gca,'CurrentPoint');
   o=ones(1,size(vectors,2));
   p=[cp(1,1)*o;cp(1,2)*o];
   [min,index]=min(max(abs(vectors(1:2,:)-p)));


function deps=delete_deps(deps,index)
   l=size(deps,2);
   for i=l:-1:1
      v1=deps{1,i};
      v2=deps{2,i};
      v3=deps{3,i};
      if v1==index | v2==index | v3==index
         inds=[];
         if i>1
            inds=[inds 1:i-1];
         end
         if i<l
            inds=[inds i+1:l];
         end
         deps=deps(:,inds);
      end
   end